#ifndef __CREARGRAFODLG_H__
#define __CREARGRAFODLG_H__

#include <qdialog.h>

class QComboBox;
class QLineEdit;

//! Cuadro de dilogo para crear un grafo.

/*!
    Este cuadro de dilogo muestra las opciones que se
    odrecen al usuario a la hora de crear un grafo.
 */
class CrearGrafoDlg:public QDialog {

    public:
        CrearGrafoDlg ( QWidget *parent = 0, const char *name = 0,
            bool modal = FALSE, WFlags f = 0 );
        virtual ~CrearGrafoDlg( void );

        //! Tipo del grafo

        /*!
            Tipos de grafos disponibles.
         */
        enum TipoGrafo { Dirigido, NoDirigido };

        QString nombre( void );
        int numNodos( void );
        TipoGrafo tipoGrafo( void );

    protected slots:
        virtual void accept( void );

    private:

        //! Cuadro combinado que muestra los tipos de grafo

        /*!
            Cuadro combinado que muestra los tipos de grafo
         */
        QComboBox *_tipoGrafo;

        //! Entrada para el nmero de nodos

        /*!
            Entrada de texto para el nmero de nodos del grafo.
         */
        QLineEdit *_numNodos;

        //! Entrada para el nombre del grafo

        /*!
            Entrada de texto para dar nombre al nuevo grafo.
         */
        QLineEdit *_nombre;
};

#endif
