#ifndef __DOCUMENTO_H__
#define __DOCUMENTO_H__

#include <qmainwindow.h>

class VistaGrafo;
class Grafo;

//! Clase documento de la aplicacion

/*!
    Esta es la clase documento de nuestra aplicacin, que gestionar
    un grafo.
 */
class Documento:public QMainWindow {
    Q_OBJECT

    public:
        Documento(  Grafo *g, QWidget * parent = 0, const char * name = 0,
            WFlags f = WType_TopLevel );
        virtual ~Documento( void );

        VistaGrafo *vista( void ) {return _vista;};
        Grafo *grafo() const;

        void modificarPesos( void );

    signals:
        //! El grafo ha sido modificado

        /*!
            El grafo ha sido modificado
         */
        void grafoModificado( void );

    private:
        void grafo( Grafo *g );

        //! Vista de este documento

        /*!
            Vista del documento.
         */
        VistaGrafo *_vista;

        //! Grafo que gestiona el documento

        /*!
            Grafo que gestiona el documento.
         */
        Grafo *_grafo;
};

#endif
