#include "grafonodirigido.h"

#include <assert.h>

GrafoNoDirigido::GrafoNoDirigido( int n ):Grafo( n )
{

}

GrafoNoDirigido::~GrafoNoDirigido()
{

}

void GrafoNoDirigido::peso( int i, int j, int valor )
{
    assert( i>=0 && i<numNodos() );
    assert( j>=0 && j<numNodos() );

    _matriz[i][j] = valor;
    _matriz[j][i] = valor;
}

Grafo *GrafoNoDirigido::copia( void )
{
    GrafoNoDirigido *nuevo=new GrafoNoDirigido( numNodos() );
    nuevo->copiaPesos( this );
    return nuevo;
}

// arbol abarcador de coste minimo
void GrafoNoDirigido::PrimMinimo( void )
{
//

int i,j;
TipoPeso k,min;

// assert(_es_arbol_abarcador==false);

// Reservas de memoria
TipoPeso *mascercano=new TipoPeso[numNodos()];
TipoPeso *menorcosto=new TipoPeso[numNodos()];

TipoPeso **CA=new TipoPeso *[numNodos()];
for(i=0;i<numNodos();i++)
    {
    CA[i]=new TipoPeso [numNodos()];
    }

// Inicializamos...
for(i=0;i<numNodos();i++)
    {
    for(j=0;j<numNodos();j++)
	{
	CA[i][j]=infinito;
	if(_matriz[i][j]==infinito && i!=j)
	    {
	    _matriz[i][j]=infinito-1;
	    }
	}
    }
for(i=1;i<numNodos();i++)
    {
    menorcosto[i]=_matriz[0][i];
    mascercano[i]=0;
    }

// Aqui empieza todo.
for(i=1;i<numNodos();i++)
    {
    min=menorcosto[1];
    k=1;
    for(j=2;j<numNodos();j++)
	{
	if(menorcosto[j]<min)
	    {
	    min=menorcosto[j];
	    k=j;
	    }
	}
    CA[k][mascercano[k]]= _matriz[k][mascercano[k]];
    CA[mascercano[k]][k]= _matriz[mascercano[k]][k]; // esta linea esta mal en el libro
    menorcosto[k]=infinito;
    for(j=1;j<numNodos();j++)
	{
	if(_matriz[k][j]<menorcosto[j] && menorcosto[j]<infinito)
	    {
	    menorcosto[j]=_matriz[k][j];
	    mascercano[j]=k;
	    }
	}
    }
_matriz=CA;
}

//arbol abarcador de coste maximo
void GrafoNoDirigido::PrimMaximo( void )
{
//

int i,j;
TipoPeso k,max;

// assert(_es_arbol_abarcador==false);

// Reservas de memoria
TipoPeso *mascercano=new TipoPeso[numNodos()];
TipoPeso *mayorcosto=new TipoPeso[numNodos()];

TipoPeso **CA=new TipoPeso *[numNodos()];
for(i=0;i<numNodos();i++)
    {
    CA[i]=new TipoPeso [numNodos()];
    }

// Inicializamos...
for(i=0;i<numNodos();i++)
    {
    for(j=0;j<numNodos();j++)
	{
	CA[i][j]=infinito;
	if(_matriz[i][j]==infinito && i!=j)
	    {
	    _matriz[i][j]=0;
	    }
	}
    }
for(i=1;i<numNodos();i++)
    {
    mayorcosto[i]=_matriz[0][i];
    mascercano[i]=0;
    }

// Aqui empieza todo.
for(i=1;i<numNodos();i++)
    {
    max=mayorcosto[1];
    k=1;
    for(j=2;j<numNodos();j++)
	{
	if(mayorcosto[j]>max) ///
	    {
	    max=mayorcosto[j];
	    k=j;
	    }
	}
    CA[k][mascercano[k]]= _matriz[k][mascercano[k]];
    CA[mascercano[k]][k]= _matriz[mascercano[k]][k]; // esta linea esta mal en el libro
    mayorcosto[k]=0;
    for(j=1;j<numNodos();j++)
	{
	if(_matriz[k][j]>mayorcosto[j] && mayorcosto[j]!=0) ///
	    {
	    mayorcosto[j]=_matriz[k][j];
	    mascercano[j]=k;
	    }
	}
    }
_matriz=CA;
}