#ifndef __INTRODUCIRPESOSDLG_H__
#define __INTRODUCIRPESOSDLG_H__

#include <qdialog.h>

class QTable;
class Grafo;

//! Dilogo para introducir pesos

/*!
    Esta clase implementa un cuadro de dilogo para introducir
    los pesos de un grafo.
 */
class IntroducirPesosDlg:public QDialog {
    Q_OBJECT

    public:
        IntroducirPesosDlg( Grafo *g, QWidget *parent = 0,
            const char *name = 0, bool modal = FALSE, WFlags f = 0 );
        virtual ~IntroducirPesosDlg();

    protected slots:
        virtual void accept( void );
        void retocarPesosNoDirigidos( int fila, int columna );

    private:
        //! Tabla de pesos

        /*!
            Tabla con los pesos del grafo a editar
         */
        QTable *_tabla;

        //! Grafo a editar

        /*!
            Grafo a editar.
         */
        Grafo *_grafo;
};

#endif
