#ifndef __PRACTICA_H__
#define __PRACTICA_H__

#include <qmainwindow.h>

class QWorkspace;
class QPopupMenu;
class InsertarLista;

//! Clase principal

/*!
    Esta es la clase principal del interfaz de usuario.
 */

class Practica:public QMainWindow {
    Q_OBJECT

    public:
        Practica ( QWidget * parent = 0, const char * name = 0,
            WFlags f = WType_TopLevel );
        virtual ~Practica();

    protected slots:
        void about( void );
        void nuevo( void );
        void seleccionarTodo( void );
        void deseleccionarTodo( void );
        void mostrarMenuVentana( void );
        void mostrarVentana( int id );
        void clasificacionTopologica( void );
        void podarGrafo( void );
        void modificarPesos( void );
	void potencia_n(void);
	void CaminosMinimos(void);
	void RedMinimaPrim(void);
	void RedMaximaPrim(void);

    private:

        //! Nombre de la aplicacin

        /*!
            Nombre de la aplicacin. Slo se usa para
            ahorrar a la hora de mostrar cuadros.
         */
        static const char appName[]="Prctica de grafos";

        //! Espacio de trabajo

        /*!
            Espacio de trabajo que contiene a las ventanas
            hijas MDI.
         */
        QWorkspace *ws;

        //! El menu Ventana

        /*!
            El menu Ventana
         */
        QPopupMenu *menuVentana;
        void crearInterfaz( void );
};

#endif
