#ifndef __VISTAGRAFO_H__
#define __VISTAGRAFO_H__

#include <qscrollview.h>
#include <vector>

class Grafo;

//! Vista de un grafo

/*!
    Vista de un documento grafo.
 */
class VistaGrafo:public QScrollView {
    Q_OBJECT

    public:
        VistaGrafo ( Grafo *g, QWidget * parent = 0,
            const char * name = 0, WFlags f = 0 );
        virtual ~VistaGrafo();

        void seleccionarTodo( bool estado );

    public slots:
        void grafoModificado( void );

    protected:
        virtual void drawContents ( QPainter * p, int clipx,
            int clipy, int clipw, int cliph );

    private:
        void crearNodos();
        void dibujarArcoNoDirigido( QPainter *p, int n1, int n2 );
        void dibujarArcoDirigido( QPainter *p, int n1, int n2 );
        QPoint widgetIntersectPoint(int xa, int ya, int xb, int yb,
            QWidget *wb);
        float getSlope(QPoint p1, QPoint p2);
        QPoint intersectPoint(QPoint p1, QPoint p2, QPoint q1, QPoint q2);

        //! Grafo a visualizar

        /*!
            Grafo que se est visualizando.
         */
        Grafo *_grafo;
        class NodoGrafo;

        //! Lista de widgets nodo

        /*!
            Lista de los widget que representan a los nodos.
         */
        vector<NodoGrafo *> _listaNodos;

        //! Es el grafo no dirigido?

        /*!
            Indica si el grafo es no dirigido.
         */
        bool _noDirigido;
};

#endif
